
/*

  Read a tape file (allowing variable block counts).

*/

#include <stdio.h>
#include <fcntl.h>

#define MAX_RECORD_SIZE 80000

/* microseconds */
#define DELAY 200000
/*
#define DELAY 100000
*/

static char *usage        = "USAGE: mtread <device>\n" ;

extern int  errno, sys_nerr ;
extern char *sys_errlist [] ;

void get_params (device, argc, argv)

char **device ;
int argc ;
char *argv [] ;

{
  if (argc != 2)
  {
    fprintf (stderr, usage) ;
    exit (1) ;
  }
  *device = argv [1] ;
}

void sys_assert (condition, usr_message)
/*

  Test `condition'.  Abort program, reporting `usr_message', if it fails.

*/
int condition ;
char *usr_message ;
{
  if (!condition)
  {
    fprintf (stderr, "ERROR: %s", usr_message) ;
    if ((errno > 0) && (errno < sys_nerr))
      fprintf (stderr, "... %s", sys_errlist [errno]) ;
    fprintf (stderr, ".\n") ;
    exit (1) ;
  }
}

void main (argc, argv)
int argc ;
char *argv [] ;
{
  char err_mess [128] ;

  char *device ;
  int src_desc ;
  int going = 1 ;

  get_params (&device, argc, argv) ;

  src_desc = open (device, O_RDONLY) ;
  strcpy (err_mess, "Failed to open \"") ;
  strcat (err_mess, device) ;
  strcat (err_mess, "\"") ;
  sys_assert (src_desc >= 0, err_mess) ;

  while (going)
  {
    char record [MAX_RECORD_SIZE] ;

    int len ;

    len = read (src_desc, record, MAX_RECORD_SIZE) ;
    sys_assert (len >= 0, "Read failed") ;
    usleep (DELAY) ;  /* Deschedule...otherwise this program hogs virtually
			 *all* the cpu cycles of the machine, probably due
			 to some scheduling cockup involving the exabyte
			 drivers */
    if (len == 0)
    {
      going = 0 ;
    }
    else
    {
      int result ;

      result = write (1, record, len) ;
      sys_assert (result >= 0, "Write failed") ;
    }
  }
  close (src_desc) ;
  exit  (0) ;
}
